/*  Figure from Kaypro Column in Micro Cornucopia Magazine Issue #41
*   ENTAB -- replace blanks with equivalent tabs
*
*   Based on Small-Tools program of the same name,
*   copyright 1982 by J. E. Hendrix, in turn based
*   on algorithm in Software Tools by Kernighan and
*   Plauger, copyright 1976.
*
*   Written for Small-C compiler vers. 2.03 (ASM)
*
*   Date:  6/27/87
*/

#include <stdioa.h>
#include "iolib.asm"
#include "call.asm"

#define NOCCARGC
#define MAXLINE 127

char tabs[MAXLINE + 1];
int tabsize = 8;

main() {

   char c;
   int col, newcol;

   fputs("ENTAB -- replaces blanks with equivalent tabs.\n",stderr);
   fputs("Usage: entab <oldfile.txt >newfile.txt\n",stderr);

   settabs();
   col=1;
   while (YES) {
       newcol = col;
       while ((c = getchar()) == ' ') {
           ++newcol;
           if (tabpos(newcol, tabs) == YES) {
               fputc('\t',stdout);
               col = newcol;
           }
       }
       if (c == '\t') {
           while (tabpos(newcol, tabs) == NO)
               ++newcol;
           fputc('\t',stdout);
           col = newcol;
           continue;
       }
       while (col < newcol) {
           fputc(' ',stdout);
           ++col;
       }
       if (c == EOF) break;
       fputc(c,stdout);
       if (c == '\n') 
           col = 1;
       else if (c == '\b')
           --col;
       else ++col;
     }
}


/*
*  set up array tabs[] with tabs at interval tabsize
*/

settabs() {
   int i;
   for (i = 0; i < MAXLINE; ++i)
       tabs[i] = NO;
   for (i = 0; i < MAXLINE; ++i)
       if ((i % tabsize)==1) tabs[i] = YES;
}


/*
*  return YES if col is a tab stop else NO
*/

tabpos(col,tabs) int col; char tabs[]; {
   if (col > MAXLINE) return YES;
   else return tabs[col];
}

